from cpl_discord.service import DiscordBotServiceABC

from bot_data.model.server import Server
from bot_graphql.abc.data_query_abc import DataQueryABC


class ServerQuery(DataQueryABC):

    def __init__(
            self,
            bot: DiscordBotServiceABC
    ):
        DataQueryABC.__init__(self, 'Server')

        self._bot = bot

        self.set_field('id', self.resolve_id)
        self.set_field('discord_id', self.resolve_discord_id)
        self.set_field('name', self.resolve_name)

    @staticmethod
    def resolve_id(server: Server, *_):
        return server.server_id

    @staticmethod
    def resolve_discord_id(server: Server, *_):
        return server.discord_server_id

    def resolve_name(self, server: Server, *_):
        guild = self._bot.get_guild(server.discord_server_id)
        return None if guild is None else guild.name
